HDU 1677 Nested Dolls

过了之后感觉以前真的做过这种类型的题。

之前一直很疑惑二级排序的优先级问题,现在发现二级排序真的没有绝对的优先级。

对于此题,若按W排序,则有1到i件物品的W均小于等于第i+1件物品(设为A)的W,那么对于第i+1件我们在[1,i]中要选取一个B,使得B.w < A.w && B.h < A.h 且B.h尽可能的大。

这就是所谓的最接近A的B。

因为对于W,后面的均大于等于前面的,所以我们需要一个尽可能大的H。

Splay_Tree实现。

#include <algorithm>
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <cstdio>
#include <queue>
#include <cmath>
#include <stack>
#include <string>
#include <map>
#include <ctime>

#pragma comment(linker, "/STACK:1024000000");
#define EPS (1e-8)
#define LL long long
#define ULL unsigned long long
#define _LL __int64
#define INF 0x3f3f3f3f
#define Mod 300

using namespace std;

struct N
{
    //info
    int son[2],pre;

    //data
    int w,h;
    int ls,rs,s;
    int Minw,Minh,Maxh;

    bool operator <(const N &a) const{
        if(w == a.w)
            return h < a.h;
        return w < a.w;
    }
}st[20010],num[20010];

int Top;

void Updata(int root)
{
    st[root].ls = 0,st[root].rs = 0;
    st[root].Minw = st[root].w;
    st[root].Minh = st[root].h;
    st[root].Maxh = st[root].h;

    if(st[root].son[0] != -1)
    {
        st[root].ls = st[st[root].son[0]].s;
        st[root].Minw = min(st[root].Minw,st[st[root].son[0]].Minw);
        st[root].Minh = min(st[root].Minh,st[st[root].son[0]].Minh);
        st[root].Maxh = max(st[root].Maxh,st[st[root].son[0]].Maxh);
    }

    if(st[root].son[1] != -1)
    {
        st[root].rs = st[st[root].son[1]].s;
        st[root].Minw = min(st[root].Minw,st[st[root].son[1]].Minw);
        st[root].Minh = min(st[root].Minh,st[st[root].son[1]].Minh);
        st[root].Maxh = max(st[root].Maxh,st[st[root].son[1]].Maxh);
    }

    st[root].s = st[root].ls + st[root].rs + 1;
}

void Push_Down(int root)
{
    ;
}

void Rotate(int root,int dir)
{
    st[st[root].pre].son[dir] = st[root].son[1^dir];
    st[root].son[1^dir] = st[root].pre;

    if(st[st[st[root].pre].pre].son[0] == st[root].pre)
        st[st[st[root].pre].pre].son[0] = root;
    else
        st[st[st[root].pre].pre].son[1] = root;
    int temp = st[root].pre;
    st[root].pre = st[st[root].pre].pre;
    st[temp].pre = root;

    if(st[temp].son[dir] != -1)
        st[st[temp].son[dir]].pre = temp;
    Updata(temp);
    Updata(root);
}

int Splay(int root,int goal)
{
    while(st[root].pre != goal)
    {
        Rotate(root,(st[st[root].pre].son[0] == root ? 0 : 1));
    }

    return root;
}

int Search_Site(int root,int site)
{
    Push_Down(root);

    int temp;

    if(st[root].ls + 1 == site)
        temp = root;
    else if(st[root].ls + 1 < site)
        temp = Search_Site(st[root].son[1],site-st[root].ls-1);
    else
        temp = Search_Site(st[root].son[0],site);

    Updata(root);
    return temp;
}

void Init(int l,int r,int &root,int pre)
{
    if(l > r)
        return ;
    int mid = (l+r)>>1;

    root = Top++;

    st[root] = num[mid];
    st[root].pre = pre,st[root].son[0] = -1,st[root].son[1] = -1;

    Init(l,mid-1,st[root].son[0],root);
    Init(mid+1,r,st[root].son[1],root);

    Updata(root);
}

void Query(int root,int w,int h,int &anw,int &MaxH)
{
    if(root == -1)
        return ;

    if(w <= st[root].w)
    {
        Query(st[root].son[0],w,h,anw,MaxH);
        return ;
    }

    if(st[root].h < h && st[root].h > MaxH)
    {
        MaxH = st[root].h;
        anw = root;
    }

    if(st[root].son[1] != -1 && st[st[root].son[1]].Minw < w && st[st[root].son[1]].Minh < h && st[st[root].son[1]].Maxh > MaxH)
    {
        Query(st[root].son[1],w,h,anw,MaxH);
    }

    Query(st[root].son[0],w,h,anw,MaxH);
}

int main()
{
    int T;

    scanf("%d",&T);

    int n;

    int root,i;

    while(T--)
    {
        scanf("%d",&n);

        root = -1;

        Top = 1;
        st[0].son[0] = -1,st[0].son[1] = -1;

        num[1].w = -1;
        num[1].h = -1;

        num[n+2].w = 1000000000;
        num[n+2].h = 1000000000;

        for(i = 2;i <= n+1; ++i)
            scanf("%d %d",&num[i].w,&num[i].h);

        sort(num+1,num+n+3);

        Init(1,n+2,root,0);

        int ans = n;

        for(i = 2;i <= n+1; ++i)
        {
            root = Splay(Search_Site(root,st[root].s),0);
            root = Splay(Search_Site(root,1),0);

            int anw = -1,MaxH = -1;

            Query(st[st[root].son[1]].son[0],num[i].w,num[i].h,anw,MaxH);

            if(anw == -1)
                continue;
            ans--;

            root = Splay(anw,0);
            root = Splay(Search_Site(root,st[anw].ls+2),0);
            root = Splay(Search_Site(root,st[anw].ls),0);

            st[st[root].son[1]].son[0] = -1;
            Updata(st[root].son[1]);
            Updata(root);
        }

        printf("%d\n",ans);
    }
    return 0;
}

HDU 1677 Nested Dolls,布布扣,bubuko.com

时间: 2024-10-23 14:47:57

HDU 1677 Nested Dolls的相关文章

UVA 11368 &amp; POJ 3636 &amp; HDU 1677 Nested Dolls(贪心 + 二分LIS)

A - Nested Dolls Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Description Dilworth is the world's most prominent collector of Russian nested dolls: he literally has thousands of them! You know, the wooden hollow dolls

HDU 1277 Nested Dolls

题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=1677 题意: 玩俄罗斯套娃,问最后至少还剩几个. 题解: 这题可以和拦截导弹做对比,因为这里是二维的,按w递减h递增的方式来保证在保存的序列中按h升序来排的,从而为二分查找打下基础. 否则,如果按h降序排,保存的序列就会无序,二分结果自然不正确了. 1 #include<iostream> 2 #include<cstdio> 3 #include<algorithm>

HDU 1677

Nested Dolls Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 2643    Accepted Submission(s): 785 Problem Description Dilworth is the world’s most prominent collector of Russian nested dolls: he

Nested Dolls (单调递增子序列 + 二分)

Description Dilworth is the world's most prominent collector of Russian nested dolls: he literally has thousands of them! You know, the wooden hollow dolls of different sizes of which the smallest doll is contained in the second smallest, and this do

hdu----(1677)Nested Dolls(DP/LIS(二维))

Nested Dolls Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 2704    Accepted Submission(s): 802 Problem Description Dilworth is the world’s most prominent collector of Russian nested dolls: he

SPOJ 3943 - Nested Dolls 最长不下降子序列LIS(二分写法)

现在n(<=20000)个俄罗斯套娃,每个都有宽度wi和高度hi(均小于10000),要求w1<w2并且h1<h2的时候才可以合并,问最少能剩几个. [LIS]乍一看跟[这题]类似,但是仔细看是有区别的,其实就相当于上一题多次求LIS,每次求完LIS后把得到的序列删去,然后重新求LIS,最后输出求LIS的次数,我一开始这样写,果然就TLE了.还是要另辟蹊径. 首先用贪心思想,先按照wi从大到小排序,wi相等的情况下hi从小到大,然后求最长不下降子序列(注意可以等于).输出其长度即可. 想

poj 3636 Nested Dolls 动态更新表的二分查找

题意: 给n个玩具,每个有属性w,h.如果w1<w2且h1<h2那么玩具1可放在玩具2里,问最后最少能有几个玩具. 分析: w升序,w相同时h降序排序后是可以贪心的,这里使用了动态维护表的二分算法,表里动态维护了每堆玩具中h的最大值(所以w相同时h要降序).这题我一开始一看是个拓扑图还想着用什么图算法..没想到直接可以贪心,不可以有思维定式啊~~ 代码: //poj 3636 //sep9 #include <iostream> #include <algorithm>

HDU - 1677Nested Dolls最长上升子序列变式

HDU - 1677 Nested Dolls Time Limit: 1000MS   Memory Limit: 32768KB   64bit IO Format: %I64d & %I64u Submit Status Description Dilworth is the world's most prominent collector of Russian nested dolls: he literally has thousands of them! You know, the

POJ3636Nested Dolls[DP LIS]

Nested Dolls Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 8323   Accepted: 2262 Description Dilworth is the world's most prominent collector of Russian nested dolls: he literally has thousands of them! You know, the wooden hollow doll